; CONSOLE #
include win64a.inc
MAXSCREENX = 80
MAXSCREENY = 25
buffersize = 100
.code
WinMain proc
local BUFF[buffersize]:byte   
local result:qword
local MOUSE_KEY:INPUT_RECORD
local ConsoleWindow:SMALL_RECT
local cci:CONSOLE_CURSOR_INFO
 
     
    	invoke  FreeConsole
        invoke  AllocConsole
        invoke  GetStdHandle,STD_INPUT_HANDLE
        mov 	hIn,rax
        invoke	GetStdHandle,STD_OUTPUT_HANDLE
        mov 	hOut,rax
    	invoke  GetLargestConsoleWindowSize,eax     
;   rax return in 31-16 bits: dwCoord.y
;                 15-00 bits: dwCoord.x
 
        lea 	r8d,ConsoleWindow       ; lpConsoleWindow
    	and 	dword ptr [r8],0
;   ConsoleWindow.Left = 0  ConsoleWindow.Top = 0
 
    	sub 	ax, MAXSCREENX
    	sbb 	edx, edx
    	and 	ax, dx
    	add 	ax, MAXSCREENX-1
    	mov 	[r8+SMALL_RECT.Right],ax
 
    	shr 	eax, 16
    	sub 	eax, MAXSCREENY
    	sbb 	edx, edx
    	and 	eax, edx
    	add 	eax, MAXSCREENY-1
    	mov 	[r8+SMALL_RECT.Bottom],ax
 
    	invoke  SetConsoleWindowInfo,hOut,TRUE 
    	invoke  SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX  ;establish the new size of console window
    	invoke  SetConsoleTitle,&NameConsole
;hide cursor----------------------------------------
    	invoke  GetConsoleCursorInfo,hOut,&cci
    	lea 	edx,cci             ; lpConsoleCursorInfo
    	mov 	[rdx+CONSOLE_CURSOR_INFO.bVisible],FALSE
    	invoke  SetConsoleCursorInfo,hOut
;------------------------------------------------------
        invoke  WriteConsole,hOut,&Str1,sizeof Str1,&result,0     
        invoke  SetConsoleCursorPosition,hOut,0B000Bh         ;Y=11 X=0
        invoke  WriteConsole,hOut,&Str2,sizeof Str2,&result,0
@@:     invoke  SetConsoleCursorPosition,hOut,0A0009h         ;Y=10 X=9
    	invoke  ReadConsoleInput,hIn,&MOUSE_KEY,1,&result
    	lea 	edx,MOUSE_KEY
    	cmp 	[rdx+INPUT_RECORD.EventType],MOUSE_EVENT
    	jne LOO1
    	xor 	eax,eax
    	mov 	ax,[rdx+INPUT_RECORD.MouseEvent.dwMousePosition.y]
    	mov 	[rsp+20h],rax
        mov 	ax,[rdx+INPUT_RECORD.MouseEvent.dwMousePosition.x]
        mov 	r8d,[rdx+INPUT_RECORD.MouseEvent.dwButtonState]
    	cmp 	r8d,4
    	sbb 	ecx,ecx
    	and 	r8d,ecx
    	invoke  wsprintf,&BUFF,&fmt,,rax
    	invoke  WriteConsole,hOut,&BUFF,eax,&result,0
    	jmp @b
LOO1:   lea     eax,MOUSE_KEY
    	cmp     [rax+INPUT_RECORD.EventType],KEY_EVENT
    	jne     @b
    	cmp     [rax+INPUT_RECORD.KeyEvent.wVirtualKeyCode],VK_ESCAPE
    	jne     @b
        invoke  FreeConsole
    	invoke	RtlExitUserProcess,NULL
WinMain endp
hIn	dq ?
hOut	dq ?
NameConsole db 'Processing of mouse messages',0
fmt db 'Button state: %u, X: %u, Y: %u',0
Str1    db 'For exit press ESC or CTRL+C'
Str2    db 'No clicks = 0',0Dh,0Ah,\
'          Left click = 1',0Dh,0Ah,\
'         Right click = 2',0Dh,0Ah,\
'Left and Right click = 3',0
end